﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FileSystem;

namespace UnitTests {
  class Program {
  static void Main(string[] args) {
      // try making a file system:
      Folder filesystem = makeSystem();
      // try printing the names of all its contents:
      Console.WriteLine("FILE SYSTEM CONTENTS:");  Console.WriteLine();
      Console.WriteLine(filesystem.ToString());

      Console.WriteLine("LOOK UP SOME ENTRIES:"); Console.WriteLine();

      // try finding and printing the contents of a textfile:
      Console.WriteLine("Search and print  a.txt:");
      Entry t = filesystem.search("a.txt");
      displayTextFile(t);   // this method is coded below

      Console.WriteLine("Search and print  F/b.txt:");
      t = filesystem.search("F/b.txt");
      displayTextFile(t);

      Console.WriteLine("Search and print  F/G/c.txt:");
      t = filesystem.searchE("F/G/c.txt");
      displayTextFile(t);

      Console.WriteLine("Search and print  F/LinkTo a:");
      Entry e  = filesystem.search("F/LinkTo a");
      displayTextFile(e);

      Console.WriteLine("Search and print  F/G/Link To Folder F/b.txt:");
      e = filesystem.searchE("F/G/Link To Folder F/b.txt");
      displayTextFile(e);

      // try it again:
      Console.WriteLine("Search and print  SillyLink/a.txt:");
      Entry f = filesystem.search("SillyLink/a.txt");
      displayTextFile(f);

      Console.ReadLine(); 
    }


    // assembles a sample filesystem whose root folder is named "Root"; returns handle.
    static Folder makeSystem() {
      Folder filesystem = new Folder("Root");

      TextFile a = new TextFile("a.txt");
      a.addLine("I am file a.txt"); a.addLine("End of a.txt");
      filesystem.add(a);

      Folder f = new Folder("F");
      filesystem.add(f);

      TextFile b = new TextFile("b.txt");
      b.addLine("I am file b.txt.  The end.");
      f.add(b);

      Shortcut s = new Shortcut("LinkTo a", a);
      f.add(s);

      Folder g = new Folder("G");
      f.add(g);

      TextFile c = new TextFile("c.txt");
      c.addLine("I am file c.txt.  The end.");
      g.add(c);
 
      g.add(new Shortcut("Link To Folder F", f));  // circular link

      Folder h = new Folder("H");
      filesystem.add(h);

      return filesystem;
    }

    // writes on the Console the lines in the textfile indicated by object  e :
    static void displayTextFile(Entry e) {
      if (e is TextFile) {
        Console.WriteLine(((TextFile)e).Lines);
      }
      else {
        Console.WriteLine("invalid entry");
      }
    }
 }  
}
